import cocos
import pymunk

from pyglet.window import key, mouse

import Actor.Blob

class GameUI( cocos.layer.base_layers.Layer ):
    is_event_handler = True

    def __init__( self, context ):
        super( GameUI, self ).__init__()
        self.level = context.level
        self.hovered = None

        self.drag_object = None
        self.context = context
        self.mousex, self.mousey = (0,0)
        self.mouseClicked = False


    def on_mouse_motion( self, x, y, dx, dy ):
        self.mousex, self.mousey = x,y
        self.hovered = None
        dist, actor = self.level.get_closest_actor_by_type(x,y, Actor.Blob.Blob)
        if dist < 100:
            if self.hovered is not None:
                self.hovered.color = (1,1,1)
            self.hovered = actor
            self.hovered.color = (0,1,0)
        return
        self.mousepos_rel = dx, dy
        self.mousepos = cocos.director.director.get_virtual_coordinates (x, y)

    def on_mouse_drag( self, x, y, dx, dy, buttons, modifiers ):
        px, py = cocos.director.director.get_virtual_coordinates (x, y)
        if self.drag_object != None:
            self.drag_object.move(px,py)
        return
        self.mousepos_rel = dx, dy
        self.mousepos = cocos.director.director.get_virtual_coordinates (x, y)


    def on_mouse_press( self, x, y, buttons, modifier ):
        #print "lol1",x,y
        self.mouseClicked = True

        dist, actor = self.level.get_closest_actor_by_type(x,y, Actor.Blob.Blob)
        if dist < 100:
            actor.toggle_type(self.context)
        return
        #print "gameui"
        #if buttons == mouse.LEFT:
            #dist, actor = self.level.get_closest_actor_by_type(x,y, Actor.Blob.Blob)
            #if dist < 100:
            #    actor.activate_skill()
            #    print "activate skill"
        #elif buttons == mouse.RIGHT:
        #    dist, actor = self.level.get_closest_actor_by_type(x,y, Actor.Blob.Blob)
        #    if dist < 100:
        #        actor.toggle_type(self.context)
            #    if self.drag_object != None:
            #        self.drag_object.detach()
            #        self.drag_object = None
            #    p = cocos.director.director.get_virtual_coordinates (x, y)
            #    self.drag_object = actor.get_drag_object(p)


    def on_mouse_release( self, x, y, button, modifier ):
        if button == mouse.RIGHT and self.drag_object != None:
            self.drag_object.detach()
            self.drag_object = None

        return
        self.buttons_new.remove( button )
