import cocos

id = 0

class DragObject:
    def __init__(self, body, detach_func):
        self.body = body
        self.detach_func = detach_func
    def move(self, x,y):
        self.body.position = (x,y)
        
    def detach(self):
        self.detach_func(self.body)
    

class Actor(cocos.cocosnode.CocosNode):
    def __init__(self, pos):
        super(Actor, self).__init__()

        global id
        self.id = id
        id += 1

        self.x, self.y = pos. x, pos.y
        print "Created %s with id %d @ %d, %d" % (str(self.__class__), self.id, self.x, self.y)

    def moveRel(self, x, y):
        self.x += x
        self.y += y

    def move(self, x, y):
        self.position = x, y
        #self.x = x
        #self.y = y

    def rotate(self, angle):
        self.rotation += angle


    def update(self, context):
        pass

    def save(self):
        return "N/A"

    def load(self, context, data):
        pass
        #if data != save():
        #    raise Exception("Weird save or load: %s" % data)

    def destroy(self, context):
        pass